<?php
/* Setting this so we can output plain text with \n characters */
header("Content-Type: text/plain");


# -----------------------------------------------------
# Associative Arrays
# -----------------------------------------------------
/*
- We will use these to build JSON output for our PHP web services!
- Analogous to Maps in Java, dictionaries in Python
- array(key0 => val0, key1 => val1, ...) # create
- $arr[$keyname] = $val; # sets key to be value (may overwrite)
*/

$petages = array();
$pets["Spot"] = 16;
$pets["Mowgli"] = 1;

$costs = array("coffee" => 1.25, "espresso" => 2.15);
$costs["tea"] = 1.50;
$costs["espresso"] = 1.75; # sale!

/*- Can turn an array into JSON using json_encode($arr)*/


# -----------------------------------------------------
# foreach loops
# -----------------------------------------------------
/*
 * Convenient ways to loop over each elements with indices
 * Syntax:
 * foreach ($arr as $variablename) {
 *
 * }
 */
 // Example
/*
$pups = array("Mowgli", "Abby", "Archie", "Bailey");
foreach ($pups as $pup) {
  echo "Mowgli boops {$pup}\n"; # even himself
}
*/

/*
 * For associative arrays the syntax is a little different:
 * Syntax:
 * foreach ($array_name as $key => $value) {
 *
 * }
 */
 // Example
/*
foreach ($pets as $key => $value) {
  echo $key . " is " . $value . " years old.\n";
}
*/

/*
 * Finding if a key exists in an array is different from finding if a value
 * exists in the array using in_array
 */
 /*
 echo in_array("Spot", $pets) . "\n";           # prints blank because it's false
 echo array_key_exists("Spot", $pets) . "\n" ;  # prints 1 for true.
*/


/*
 * explode and implode convert between strings and arrays.
 */
/*
$str = "This is a test of the emergency broadcast system... ";
$arr = explode(" ", $str);
print_r($arr);
$str2 = implode("...", $arr);
print ($str2)
*/

/*
 * Testing for null or unset variables
 */
/*
$name = "Pascal";
$name = NULL;
if (isset($name)) {
  echo "This line isn't going to be printed";
}
*/

# -----------------------------------------------------
# File I/O
# -----------------------------------------------------
/*
 * The file function returns lines of a file as an array
 * (\n at end of each). use FILE_IGNORE_NEW_LINES if you
 * want to strip the \n from each line
 */

/*
$contents = file("file.txt");
print_r($contents);

foreach ($contents as $line) {
  print $line;
}

$contents = file("file.txt", FILE_IGNORE_NEW_LINES);
foreach ($contents as $line) {
  print $line;
}
*/



/*
 * The file_get_contents function returns returns entire contents of a file as a single string.
 */
/*
$contents = file_get_contents("file.txt");
print($contents);
*/

/*
 * We can also write to a file using file_put_contents. This takes the file name to write
 * to as well as the stream of data to write. You can also specify if you should append to the
 * end of the file, or by default, it will create a new file.
 */
/*
$contents = file_put_contents("newfile.txt", "I am up too late\n" .
                                             "Lecture will not write itself\n" .
                                             "Cat meows, wants more food\n");
*/
/*
$contents = file_put_contents("newfile.txt", "    Another line");  // won't append, will overwrite
*/
/*
$contents = file_put_contents("newfile.txt", "    Another different line line", FILE_APPEND);
*/


/*
 * glob returns all of the files that match a pattern in an array`
 */
/*
$files = glob("../*");
foreach ($files as $file) {
  print ($file) . "\n";
}
*/
/*
$files = glob("../*");
foreach ($files as $file) {
  print (basename($file)) . "\n";
}
*/
/*
$files = glob("../*.html");
foreach ($files as $file) {
  print ($file) . "\n";
}
*/


/*
 * scandir returns an array of all files in the current directory, including . and ..
 * but you don't need basename() to strip the directory information from the file name
 */
/*
$files = scandir("../");
foreach ($files as $file) {
  print ( "I found a file: $file \n");
}
*/


?>
